// sample file to reproduce doxygen issue.

#include <stdio.h>
#include <stdlib.h>

// generate list of enums
#define LIST_ITEM(name) e_##name,
/*! \brief Items enumerated */
typedef enum {
#include "list.h"
	e_count
} enum_list_t;

// generate funtion prototypes
#define LIST_ITEM(name) static void name(void);
/*! \brief function prototypes */
#include "list.h"

// generate list of function pointers
#define LIST_ITEM(name) name,
/*! \brief pointers to functions */
static void (*fn[])(void) = {
#include "list.h"
};

// generate name list
#define LIST_ITEM(name) #name,
/*! \brief names of items */
static const char *names[] = {
#include "list.h"
};

// item handlers
static void item1(void)
{
	printf("item 1 handler\n");
}

static void item2(void)
{
	printf("handler for item 2\n");
}

int main(int argc, char *argv[])
{
	int num;

	if(argc < 2)
		return -1;

	num = atoi(argv[1]);

	if(!num || num > e_count)
		return -1;

	num--;
	printf("calling %s\n", names[num]);
	fn[num]();

	return 0;
}
